//Distance sensor
#define TRIG 8
#define ECHO 9

//RGB sensor
#include <Wire.h>
#include "Adafruit_TCS34725.h"
Adafruit_TCS34725 tcs = Adafruit_TCS34725();

//Wheels
int in1 = 2;
int in2 = 4;
int enA = 3;

int in3 = 5;
int in4 = 7;
int enB = 6;


void setup() {
  Serial.begin(9600);

  //Distance sensor
  pinMode(TRIG, OUTPUT);
  pinMode(ECHO, INPUT);

  //Wheels
  pinMode(enA, OUTPUT);
  pinMode(in1, OUTPUT);
  pinMode(in2, OUTPUT);
  pinMode(enB, OUTPUT);
  pinMode(in3, OUTPUT);
  pinMode(in4, OUTPUT);
}


void loop() {
  //Distance sensor
  digitalWrite(TRIG, LOW);
  delayMicroseconds(2);
  digitalWrite(TRIG, HIGH);
  delayMicroseconds(5);
  digitalWrite(TRIG, LOW);

  float t = pulseIn(ECHO, HIGH);
  float distance = t * 0.017015;
  Serial.print("Distance: "); //Test the distance sensor
  Serial.print(distance);
  Serial.println(" ");

  //RGB sensor
  uint16_t r, g, b, c, colorTemp, lux;

  tcs.getRawData(&r, &g, &b, &c);
  colorTemp = tcs.calculateColorTemperature(r, g, b);
  lux = tcs.calculateLux(r, g, b);

  Serial.print("R: "); Serial.print(r, DEC); Serial.print(" "); //Test the RGB sensor
  Serial.print("G: "); Serial.print(g, DEC); Serial.print(" ");
  Serial.print("B: "); Serial.print(b, DEC); Serial.print(" ");
  Serial.print("TEMP: "); Serial.print(colorTemp, DEC); Serial.print(" ");
  Serial.println(" ");


  if (distance > 15) {
    digitalWrite(in1, LOW); //Move forwards
    digitalWrite(in2, HIGH);
    digitalWrite(in3, LOW);
    digitalWrite(in4, HIGH);
    digitalWrite(enA, 100);
    digitalWrite(enB, 100);
  }

  else {
    digitalWrite(in1, LOW); //Stop for 1 second
    digitalWrite(in2, LOW);
    digitalWrite(in3, LOW);
    digitalWrite(in4, LOW);
    digitalWrite(enA, 0);
    digitalWrite(enB, 0);
    delay(1000);
    
    if (r < 8) {
      digitalWrite(in1, HIGH); //Turn left
      digitalWrite(in2, LOW);
      digitalWrite(in3, LOW);
      digitalWrite(in4, HIGH);
      digitalWrite(enA, 100);
      digitalWrite(enB, 100);
      delay(750);
    }
    
    else {
    digitalWrite(in1, LOW); //Turn right
      digitalWrite(in2, HIGH);
      digitalWrite(in3, HIGH);
      digitalWrite(in4, LOW);
      digitalWrite(enA, 100);
      digitalWrite(enB, 100);
      delay(1000);
    }
    
    digitalWrite(in1, LOW); //Stop for 1 second
    digitalWrite(in2, LOW);
    digitalWrite(in3, LOW);
    digitalWrite(in4, LOW);
    digitalWrite(enA, 0);
    digitalWrite(enB, 0);
    delay(750);
  }
}
